VERSION 5.00
Begin VB.UserControl TableSelector 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   720
   InvisibleAtRuntime=   -1  'True
   Picture         =   "TableSelector.ctx":0000
   ScaleHeight     =   570
   ScaleWidth      =   720
   ToolboxBitmap   =   "TableSelector.ctx":0391
End
Attribute VB_Name = "TableSelector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'==========================================================
'           Copyright Information
'==========================================================
'Program Name: Mewsoft Table Selector ActiveX Control
'Program Author   : Elsheshtawy, A. A.
'Home Page        : http://www.mewsoft.com
'Copyrights  2006 Mewsoft Corporation. All rights reserved.
'
' We Provide Full Featured Open Source Code Products:
'   Auction Software        - Run your own auction site in minutes
'   Classifieds Software    - Run your own classifieds site
'   Directory and Pay Per Click Search Engine Software
'   Forum and Buliten Board System Software
'   Traffic Builder Software
'   Site Builder and Content Managment Software
'   Backupawy - Backup you website and servers automatically, Never loose your sites again
'   Validawy  - Live validate and filter your mail lists with this 500 multi-threaded validator
'   Lots or free ActiveX and VB Open Source Products
'   For download, support, details, please check our website:
'                   http://www.mewsoft.com
'==========================================================
'==========================================================
Option Explicit

'----------------------------------------------------------
Private m_bLicense As Boolean
Private Const m_sLicenseKey = "o0r18d53yo0lw4qvp0o00o"
'----------------------------------------------------------
Public Enum CellFillStyle
    HS_HORIZONTAL = 0
    HS_VERTICAL = 1
    HS_FDIAGONAL = 2
    HS_BDIAGONAL = 3
    HS_CROSS = 4
    HS_DIAGCROSS = 5
    HS_Solid = 6
End Enum

Private Const m_sDefaultStatusFormat = "%R% by %C% Table"
Private Const m_sDefaultStatusCancel = "Cancel"

Public Event TableSelected(ByVal Rows As Long, ByVal Cols As Long, Cancel As Boolean)
Public Event TableSelectionChanged(ByVal Rows As Long, ByVal Cols As Long, Cancel As Boolean)

Public Sub Show(ByVal lhWnd As Long, ByVal X As Long, ByVal Y As Long)

    Dim pt As POINTAPI
    
    ' x,y are in twips relative to the screen
    ' we'll convert them to Client coordinates
    pt.X = X / Screen.TwipsPerPixelX
    pt.Y = Y / Screen.TwipsPerPixelX
    
    'ScreenToClient lHwnd, pt
    ClientToScreen lhWnd, pt
    
    ' Show the drop down:
    'DefaultSize picDropDown
    'm_cDW.Show pt.X * Screen.TwipsPerPixelX, pt.Y * Screen.TwipsPerPixelY
    'Draw m_cDW, 0, 0, 0
    
    frmTableSelector.ShowTablePicker pt.X * Screen.TwipsPerPixelX, pt.Y * Screen.TwipsPerPixelY
    'frmTableSelector.ShowTablePicker pt.X, pt.Y
        
End Sub

Public Sub Hide()
    frmTableSelector.HideDropDown
End Sub

Public Property Get hwnd() As Long
Attribute hwnd.VB_UserMemId = -515
   hwnd = UserControl.hwnd
End Property


Property Let SerialNumber(sValue As String)
    
    If sValue = m_sLicenseKey Then
        m_bLicense = True
    Else
        m_bLicense = False
    End If
    
End Property

'====================================================================
Private Sub UserControl_Initialize()
    
    Set CallUserControl = Me
    
    'm_bLicense = False ' Trial version or full version
    m_bLicense = True
    
End Sub

'====================================================================
Private Sub UserControl_Resize()

    UserControl.Width = 16 * Screen.TwipsPerPixelX
    UserControl.Height = 16 * Screen.TwipsPerPixelY
    
End Sub

'====================================================================
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_lCellWidth = PropBag.ReadProperty("CellWidth", 20)
    m_lCellHeight = PropBag.ReadProperty("CellHeight", 20)
    
    m_lStartRows = PropBag.ReadProperty("StartRows", 4)
    
    m_lStartColumns = PropBag.ReadProperty("StartColumns", 5)
    
    m_lInCellFillStyle = PropBag.ReadProperty("InCellFillStyle", 6)
    
    m_lCellFillStyle = PropBag.ReadProperty("CellFillStyle", 6)
    
    m_lCellBackColor = PropBag.ReadProperty("CellBackColor", vbWhite)
    
    m_lInCellBackColor = PropBag.ReadProperty("InCellBackColor", vbBlue)
    
    m_lBackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
    
    m_oStatusFont = PropBag.ReadProperty("Font", UserControl.Font)
    
    m_lStatusBackColor = PropBag.ReadProperty("StatusBackColor", vbButtonFace)
    
    m_lBorderColor = PropBag.ReadProperty("BorderColor", vbBlack)
    
    m_lHiBorderColor = PropBag.ReadProperty("HiBorderColor", vbBlue)
    
    m_sStatusFormat = PropBag.ReadProperty("StatusFormat", m_sDefaultStatusFormat)
    
    m_sStatusCancel = PropBag.ReadProperty("StatusCancel", m_sDefaultStatusCancel)
    
    m_bStatusRightToLeft = PropBag.ReadProperty("StatusRightToLeft", False)
    
    m_lCellSpacing = PropBag.ReadProperty("CellSpacing", 1)
    
    m_lCellBorderSize = PropBag.ReadProperty("CellBorderSize", 1)
    
    m_lCellBorderColor = PropBag.ReadProperty("CellBorderColor", vbBlack)
    
End Sub

'====================================================================
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "CellWidth", m_lCellWidth, 20
    PropBag.WriteProperty "CellHeight", m_lCellHeight, 20
    
    PropBag.WriteProperty "StartRows", m_lStartRows, 4
    PropBag.WriteProperty "StartColumns", m_lStartColumns, 5
    
    PropBag.WriteProperty "InCellFillStyle", m_lInCellFillStyle, 6
    
    PropBag.WriteProperty "CellFillStyle", m_lCellFillStyle, 6
    
    PropBag.WriteProperty "CellBackColor", m_lCellBackColor, vbWhite
    PropBag.WriteProperty "InCellBackColor", m_lInCellBackColor, vbBlue
    
    PropBag.WriteProperty "BackColor", m_lBackColor, vbButtonFace
    
    PropBag.WriteProperty "Font", m_oStatusFont, UserControl.Font
    PropBag.WriteProperty "StatusBackColor", m_lStatusBackColor, vbButtonFace
    
    PropBag.WriteProperty "BorderColor", m_lBorderColor, vbBlack
    
    PropBag.WriteProperty "HiBorderColor", m_lHiBorderColor, vbBlue
    
    PropBag.WriteProperty "StatusFormat", m_sStatusFormat, m_sDefaultStatusFormat
    
    PropBag.WriteProperty "StatusCancel", m_sStatusCancel, m_sDefaultStatusCancel
    PropBag.WriteProperty "StatusRightToLeft", m_bStatusRightToLeft, False
    
    PropBag.WriteProperty "CellSpacing", m_lCellSpacing, 1
    
    PropBag.WriteProperty "CellBorderSize", m_lCellBorderSize, 1
    
    PropBag.WriteProperty "CellBorderColor", m_lCellBorderColor, vbBlack
    
End Sub

'====================================================================
Public Property Get CellWidth() As Long
    CellWidth = m_lCellWidth
End Property

Public Property Let CellWidth(ByVal lWidth As Long)
    m_lCellWidth = lWidth
    If m_lCellWidth < 1 Then m_lCellWidth = 1
    PropertyChanged "CellWidth"
End Property

'====================================================================
Public Property Get CellHeight() As Long
    CellHeight = m_lCellHeight
End Property

Public Property Let CellHeight(ByVal lHeight As Long)
    m_lCellHeight = lHeight
    If m_lCellHeight < 1 Then m_lCellHeight = 1
    PropertyChanged "CellHeight"
End Property

'====================================================================
Public Property Get StartRows() As Long
    StartRows = m_lStartRows
End Property

Public Property Let StartRows(ByVal lRows As Long)
    m_lStartRows = lRows
    If m_lStartRows < 1 Then m_lStartRows = 1
    PropertyChanged "StartRows"
End Property

'====================================================================
Public Property Get StartColumns() As Long
    StartColumns = m_lStartColumns
End Property

Public Property Let StartColumns(ByVal lColumns As Long)
    m_lStartColumns = lColumns
    If m_lStartColumns < 1 Then m_lStartColumns = 1
    PropertyChanged "StartColumns"
End Property

'====================================================================
Public Property Get InCellFillStyle() As CellFillStyle
    InCellFillStyle = m_lInCellFillStyle
End Property

Public Property Let InCellFillStyle(ByVal lStyle As CellFillStyle)
    m_lInCellFillStyle = lStyle
    PropertyChanged "InCellFillStyle"
End Property

'====================================================================
Public Property Get CellFillStyle() As CellFillStyle
    CellFillStyle = m_lCellFillStyle
End Property

Public Property Let CellFillStyle(ByVal lStyle As CellFillStyle)
    m_lCellFillStyle = lStyle
    PropertyChanged "CellFillStyle"
End Property

'====================================================================
Public Property Get CellBackColor() As OLE_COLOR
    CellBackColor = m_lCellBackColor
End Property

Public Property Let CellBackColor(ByVal lCellBackColor As OLE_COLOR)
    m_lCellBackColor = lCellBackColor
    PropertyChanged "CellBackColor"
End Property

'====================================================================
Public Property Get InCellBackColor() As OLE_COLOR
    InCellBackColor = m_lInCellBackColor
End Property

Public Property Let InCellBackColor(ByVal lInCellBackColor As OLE_COLOR)
    m_lInCellBackColor = lInCellBackColor
    PropertyChanged "InCellBackColor"
End Property

'====================================================================
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Sets/returns the Status text. Example: %R% by %C% Table. %R% is the Row and %C% is the Column"
    BackColor = m_lBackColor
End Property

Public Property Let BackColor(ByVal lBackColor As OLE_COLOR)
    m_lBackColor = lBackColor
    PropertyChanged "BackColor"
End Property

'====================================================================
Public Property Get Font() As StdFont
    Set Font = m_oStatusFont
End Property

Public Property Let Font(ByVal oFont As StdFont)
    m_oStatusFont = oFont
    PropertyChanged "Font"
End Property

Public Property Set Font(ByVal oFont As StdFont)
    m_oStatusFont = oFont
    PropertyChanged "Font"
End Property

'====================================================================
Public Property Get StatusBackColor() As OLE_COLOR
    StatusBackColor = m_lStatusBackColor
End Property

Public Property Let StatusBackColor(ByVal lStatusBackColor As OLE_COLOR)
    m_lStatusBackColor = lStatusBackColor
    PropertyChanged "StatusBackColor"
End Property

'====================================================================
Public Property Get BorderColor() As OLE_COLOR
    BorderColor = m_lBorderColor
End Property

Public Property Let BorderColor(ByVal lBorderColor As OLE_COLOR)
    m_lBorderColor = lBorderColor
    PropertyChanged "BorderColor"
End Property

'====================================================================
Public Property Get HiBorderColor() As OLE_COLOR
    HiBorderColor = m_lHiBorderColor
End Property

Public Property Let HiBorderColor(ByVal lHiBorderColor As OLE_COLOR)
    m_lHiBorderColor = lHiBorderColor
    PropertyChanged "HiBorderColor"
End Property

'====================================================================
Public Property Get StatusFormat() As String
    StatusFormat = m_sStatusFormat
End Property

Public Property Let StatusFormat(ByVal sStatusFormat As String)
    m_sStatusFormat = sStatusFormat
    PropertyChanged "StatusFormat"
End Property

'====================================================================
Public Property Get StatusCancel() As String
    StatusCancel = m_sStatusCancel
End Property

Public Property Let StatusCancel(ByVal sStatusCancel As String)
    m_sStatusCancel = sStatusCancel
    PropertyChanged "StatusCancel"
End Property

Public Property Get StatusRightToLeft() As Boolean
    StatusRightToLeft = m_bStatusRightToLeft
End Property

Public Property Let StatusRightToLeft(ByVal bStatus As Boolean)
    m_bStatusRightToLeft = bStatus
    PropertyChanged "StatusRightToLeft"
End Property

Public Property Get CellSpacing() As Long
    CellSpacing = m_lCellSpacing
End Property

Public Property Let CellSpacing(ByVal lCellSpacing As Long)
    m_lCellSpacing = lCellSpacing
    PropertyChanged "CellSpacing"
End Property

Public Property Get CellBorderSize() As Long
    CellBorderSize = m_lCellBorderSize
End Property

Public Property Let CellBorderSize(ByVal lCellBorderSize As Long)
    m_lCellBorderSize = lCellBorderSize
    PropertyChanged "CellBorderSize"
End Property

Public Property Get CellBorderColor() As OLE_COLOR
    CellBorderColor = m_lCellBorderColor
End Property

Public Property Let CellBorderColor(ByVal lCellBorderColor As OLE_COLOR)
    m_lCellBorderColor = lCellBorderColor
    PropertyChanged "CellBorderColor"
End Property

Public Property Get MaxRows() As Long
    MaxRows = m_lMaxRows
End Property

Public Property Let MaxRows(ByVal lMaxRows As Long)
    m_lMaxRows = lMaxRows
    'If m_lMaxRows < 0 Then m_lMaxRows = 0
    PropertyChanged "MaxRows"
End Property

Public Property Get MaxCols() As Long
    MaxCols = m_lMaxCols
End Property

Public Property Let MaxCols(ByVal lMaxCols As Long)
    m_lMaxCols = lMaxCols
    'If m_lMaxCols < 0 Then m_lMaxCols = 0
    PropertyChanged "MaxCols"
End Property


'====================================================================
'                       Events
'====================================================================
Public Sub EventTableSelected(Rows As Long, Cols As Long, bCancel As Boolean)
    
    If m_bLicense Then
        RaiseEvent TableSelected(Rows, Cols, bCancel)
    Else
        RaiseEvent TableSelected(0&, 0&, bCancel)
    End If
    
End Sub

Public Sub EventTableSelectionChanged(Rows As Long, Cols As Long, bCancel As Boolean)
    
    If m_bLicense Then
        RaiseEvent TableSelectionChanged(Rows, Cols, bCancel)
    Else
        RaiseEvent TableSelectionChanged(0, 0, bCancel)
    End If
    
End Sub
'====================================================================
'====================================================================

